﻿Imports Microsoft.Data.SqlClient
Public Class Form1
    Private Structure tools
        Dim tool_id As Integer
        Dim tool_name As String
    End Structure

    Private Sub Form1_Shown(sender As Object, e As EventArgs) Handles Me.Shown
        Dim connStr As String = "Data Source=(LocalDB)\MSSQLLocalDB;AttachDbFilename=C:\Users\hoeol01\source\repos\Test_Matrix\Test_Matrix\Database1.mdf;Integrated Security=True"
        Dim listTools As New List(Of tools)

        Using conn As New SqlConnection With {.ConnectionString = connStr}
            Try
                conn.Open()

                'Alle Werkzeuge auslesen und in einer Liste speichern
                Using cmd As New SqlCommand With {.Connection = conn}
                    cmd.CommandText = "SELECT tool_id, tool_name FROM tool;"
                    Using reader As SqlDataReader = cmd.ExecuteReader
                        If reader.HasRows Then
                            While reader.Read
                                Dim tool As New tools With {
                                    .tool_id = Convert.ToInt32(reader("tool_id")),
                                    .tool_name = Convert.ToString(reader("tool_name"))
                                }
                                listTools.Add(tool)
                            End While
                        End If
                    End Using
                End Using

                If listTools.Count > 0 Then
                    For Each tool In listTools
                        'Eine Spalte als WKZ-Name erzeugen
                        '......
                        DataGridView1.Columns.Add(tool.tool_id.ToString, tool.tool_name)
                    Next
                End If
            Catch ex As Exception

            Finally
                conn.Close()
            End Try
        End Using

    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles Me.Load
        DataGridView1.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.EnableResizing
        DataGridView1.ColumnHeadersHeight = 40
        DataGridView1.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.AllCellsExceptHeader

        AddHandler DataGridView1.CellPainting, AddressOf PaintCell
    End Sub

    Private Sub PaintCell(sender As Object, e As DataGridViewCellPaintingEventArgs)
        'Nur die Header-Zelle verändern!
        If e.RowIndex = -1 AndAlso e.ColumnIndex >= 0 Then
            e.PaintBackground(e.ClipBounds, True)
            Dim rect As Rectangle = DataGridView1.GetColumnDisplayRectangle(e.ColumnIndex, True)
            Dim font As New Font("Segoe UI", 20, FontStyle.Bold)
            Dim titleSize As Size = TextRenderer.MeasureText(e.Value.ToString, e.CellStyle.Font)
            If DataGridView1.ColumnHeadersHeight < titleSize.Width Then
                DataGridView1.ColumnHeadersHeight = titleSize.Width
            End If

            e.Graphics.TranslateTransform(0, titleSize.Width)
            e.Graphics.RotateTransform(-90.0F)

            e.Graphics.DrawString(e.Value.ToString, Me.Font, Brushes.Black, New PointF(rect.Y - (DataGridView1.ColumnHeadersHeight - titleSize.Width), rect.X))

            e.Graphics.RotateTransform(90.0F)
            e.Graphics.TranslateTransform(0, -titleSize.Width)
            e.Handled = True
        End If
    End Sub
End Class
